// BkgrndSoundDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BkgrndSound.h"
#include "BkgrndSoundDlg.h"
#include <MmSystem.h>
#pragma comment(lib, "WinMM")

#ifdef _DEBUG
   #define new DEBUG_NEW
#undef THIS_FILE
   static char THIS_FILE[] = __FILE__;
#endif

#define HTML_BODY_PREFIX _T("<BGSOUND id='id_BgSound' src='")

const COMPONENT g_Cmpnnt = {
   sizeof(COMPONENT),
   0,
   COMP_TYPE_HTMLDOC,
   TRUE,
   FALSE,
   FALSE,
   {sizeof(COMPPOS), 0,0,0,0, 0, !FALSE, !FALSE, !FALSE, 0,0},
   {NULL},
   {NULL},
   {NULL},//OLESTR("tempHTML2"),
   IS_NORMAL,
   {sizeof(COMPSTATEINFO), 0,0,0,0, IS_SPLIT},
   {sizeof(COMPSTATEINFO), 0,0,0,0, IS_SPLIT}
};

/////////////////////////////////////////////////////////////////////////////
// CBkgrndSoundDlg dialog

CBkgrndSoundDlg::CBkgrndSoundDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBkgrndSoundDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBkgrndSoundDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBkgrndSoundDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBkgrndSoundDlg)
	DDX_Control(pDX, IDC_COMBO_PERIOD, m_ctrlComboPeriod);
	DDX_Control(pDX, IDC_CHECK_REPEAT, m_ctrlCheckRepeat);
	DDX_Control(pDX, IDOK, m_ctrlBttnOk);
	DDX_Control(pDX, IDC_EDIT_FILE, m_ctrlEditFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBkgrndSoundDlg, CDialog)
	//{{AFX_MSG_MAP(CBkgrndSoundDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_FILE, OnButtonFile)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_CHECK_REPEAT, OnCheckRepeat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBkgrndSoundDlg message handlers

BOOL CBkgrndSoundDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//m_ctrlCheckRepeat.SetCheck(BST_CHECKED);
   if (CBkgrndSoundDlg::FindOrRemove(TRUE)) {
      ::EnableWindow(::GetDlgItem(m_hWnd, IDC_BUTTON_STOP), TRUE);
   }
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_TIMEOUT), _T("0"));
   m_ctrlCheckRepeat.EnableWindow(FALSE);
   m_ctrlComboPeriod.EnableWindow(FALSE);

   //m_ctrlComboPeriod.AddString(_T("seconds"));
   //m_ctrlComboPeriod.AddString(_T("minutes"));
   //m_ctrlComboPeriod.AddString(_T("hours"));
   m_ctrlComboPeriod.SetCurSel(0);//.SendMessage(WM_KEYDOWN, VK_DOWN, 0);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBkgrndSoundDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBkgrndSoundDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBkgrndSoundDlg::OnButtonFile() 
{
   CString strFile(::SelectFile(TRUE, m_hWnd, NULL, NULL, _T("All supported your system music file (*.*)\0*.*\0\0")));
   if (!strFile.IsEmpty()) {
      m_ctrlEditFile.SetWindowText(strFile);
      m_ctrlBttnOk.EnableWindow();
      m_ctrlCheckRepeat.EnableWindow();

      //   
      TCHAR szResult[64] = {0};
      TCHAR szShortFileName[MAX_PATH] = {0};
      DWORD dwRes = ::GetShortPathName(strFile, szShortFileName, MAX_PATH);
      if (dwRes) {
         strFile = szShortFileName;
      }
      MCIERROR dwErr = ::mciSendString(_T("status ")+strFile+_T(" length"), szResult, sizeof(szResult), NULL);
      if (dwErr == NO_ERROR) {
         m_strDuration = szResult;
      } else {
         m_strDuration.Empty();
      }
   }

   OnCheckRepeat();
   OnCheckRepeat();
}

void CBkgrndSoundDlg::OnOK() 
{
   if (::IsWindowEnabled(::GetDlgItem(m_hWnd, IDC_BUTTON_STOP))) {
      CBkgrndSoundDlg::FindOrRemove(FALSE);
   }

   CString strFileMusic = ::GetTempPath() + ::GUID2String(::CoCreateGuid());
   CString strFileHTML  = ::GetTempPath() + ::GUID2String(::CoCreateGuid());//+".html";

   BOOL bRes =  FALSE;

   // copy music file
   {
      ::SetCursor(::LoadCursor(::AfxGetInstanceHandle(), IDC_WAIT));

      bRes = ::CreateHardLink(strFileMusic, ::GetWindowText(m_ctrlEditFile.m_hWnd), NULL);

      if (!bRes) {
         LONGLONG llFileSize = ::GetFileSizeEx(::GetWindowText(m_ctrlEditFile.m_hWnd));
         static const LONGLONG llMaxFileCopy = LONGLONG(LONGLONG(LONGLONG(5) << 10) << 10); // max - 5Mb
         if (llFileSize > llMaxFileCopy) {
            strFileMusic = ::GetWindowText(m_ctrlEditFile.m_hWnd); //   ,   ,    ,      ...
         } else {
            bRes = ::CopyFile(::GetWindowText(m_ctrlEditFile.m_hWnd), strFileMusic, FALSE);
         }
      }

      ::SetCursor(::LoadCursor(::AfxGetInstanceHandle(), IDC_ARROW));
   }

   // create HTML file
   if (bRes) {
      bRes = FALSE;
      HANDLE hFileHTML = ::CreateFile(
         strFileHTML,
         GENERIC_WRITE,
         FILE_SHARE_READ,
         NULL,
         CREATE_ALWAYS,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFileHTML != INVALID_HANDLE_VALUE) {
         CString strBodyHTML;
         if (m_ctrlCheckRepeat.GetCheck() != BST_CHECKED) {
            //    
            strBodyHTML = HTML_BODY_PREFIX + strFileMusic + _T("' loop='1'>");
         } else {
            //   
            CString strTimeout = ::GetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_TIMEOUT));
            if (m_strDuration.IsEmpty() || strTimeout.IsEmpty()  || (strTimeout == _T("0"))) {
               //   
               strBodyHTML = HTML_BODY_PREFIX + strFileMusic + _T("' loop='-1'>");
            } else {
               //    
               int iSel = m_ctrlComboPeriod.GetCurSel();
               CString strMultiply;
               switch (iSel) {
               case 0: strMultiply = _T("*1000"   ); break; //  -> 
               case 1: strMultiply = _T("*60000"  ); break; //   -> 
               case 3: strMultiply = _T("*3600000"); break; //     -> 
               }
               strBodyHTML = HTML_BODY_PREFIX + strFileMusic + _T("' loop='1'>\r\n")
                             _T("<script type='text/javascript'>\r\n\twindow.setInterval('id_BgSound.src = id_BgSound.src;', ")+m_strDuration+_T('+')+strTimeout+strMultiply+_T(");\r\n</script>");
            }
         }
         DWORD dwSize = strBodyHTML.GetLength();
         DWORD dwNBW = 0;
         USES_CONVERSION;
         if (::WriteFile(hFileHTML, (LPCVOID)T2CA((LPCTSTR)strBodyHTML), dwSize, &dwNBW, NULL) && (dwSize == dwNBW)) {
            // all Ok
            bRes = TRUE;
         }
         ::CloseHandle(hFileHTML); hFileHTML = NULL;
      }
   }

   // Insert HTML file into the Desktop
   HRESULT hRes = E_FAIL;
   if (bRes) {
      COMPONENT cmpnnt = g_Cmpnnt;
      USES_CONVERSION;
      //lstrcpynW(cmpnnt.wszFriendlyName, T2CW(/*_T("Music ") + */::GUID2String(::CoCreateGuid())), MAX_PATH);
      lstrcpynW(cmpnnt.wszFriendlyName, T2CW(_T("about:blank                                                                         ") + ::GUID2String(::CoCreateGuid())), MAX_PATH);
      lstrcpynW(cmpnnt.wszSource, T2CW(strFileHTML), INTERNET_MAX_URL_LENGTH);

      hRes = g_pActiveDesktop->AddDesktopItem(&cmpnnt, 0);
      if (SUCCEEDED(hRes)) {
         hRes = g_pActiveDesktop->ApplyChanges(AD_APPLY_ALL);
      }
   }

	CDialog::OnOK();
}

/* static */ BOOL CBkgrndSoundDlg::FindOrRemove(BOOL bFind) {
   //    ?
   BOOL bResultFind = FALSE;
   BOOL bApplyChanges = FALSE;
   int iCount = 0;
gt_Anew:
   HRESULT hRes = g_pActiveDesktop->GetDesktopItemCount(&iCount, 0);
   if (SUCCEEDED(hRes)) {
      BOOL bDesktopItemCountChanged = FALSE;
      for (int i=0; i<iCount; i++) {
         if (bDesktopItemCountChanged) goto gt_Anew;
         COMPONENT cmpnnt = g_Cmpnnt;
         hRes = g_pActiveDesktop->GetDesktopItem(i, &cmpnnt, 0);
         if (SUCCEEDED(hRes)) {
            //USES_CONVERSION;
            static const DWORD dwMaxFileSize = 1024;
            GUID guid;
            CString strFileHTML((cmpnnt.iComponentType == COMP_TYPE_HTMLDOC) ? cmpnnt.wszSource : NULL);
            if ((cmpnnt.iComponentType == COMP_TYPE_HTMLDOC) && 
                ::String2GUID(::GetFileName(strFileHTML), guid) &&
                ::FileExist(strFileHTML) && 
                (dwMaxFileSize > ::GetFileSize(strFileHTML))
               )
            {
               // read HTML file
               CHAR szBuff[dwMaxFileSize] = {0};
               HANDLE hFile = ::CreateFile(
                  strFileHTML,
                  GENERIC_READ,
                  FILE_SHARE_READ,
                  NULL,
                  OPEN_EXISTING,
                  FILE_ATTRIBUTE_NORMAL,
                  NULL
               );
               if (hFile != INVALID_HANDLE_VALUE) {
                  DWORD dwNBR = 0;
                  BOOL bRes = ::ReadFile(hFile, (LPVOID)szBuff, dwMaxFileSize, &dwNBR, NULL) && (dwNBR < dwMaxFileSize);
                  ::CloseHandle(hFile); hFile = NULL;
                  if (bRes) {
                     // Selection music file name
                     CString strBodyHTML(szBuff, dwNBR);
                     int iPos = strBodyHTML.Find(HTML_BODY_PREFIX);
                     if (iPos == 0) {
                        CString strFileMusic(strBodyHTML.Mid(lstrlen(HTML_BODY_PREFIX)));
                        iPos = strFileMusic.ReverseFind(_T('}'));
                        if (iPos != -1) {
                           strFileMusic = strFileMusic.Left(iPos+1);
                           if (::String2GUID(::GetFileName(strFileMusic), guid)) {
                              if (bFind) {
                                 bResultFind = TRUE;
                                 break;
                              } else {
                                 // All Ok - delete file and specified desktop item
                                 bRes = ::DeleteFile(strFileMusic);
                                 bRes = ::DeleteFile(strFileHTML);
                                 hRes = g_pActiveDesktop->RemoveDesktopItem(&cmpnnt, 0);
                                 if (SUCCEEDED(hRes)) {
                                    bApplyChanges = TRUE;
                                    bDesktopItemCountChanged = TRUE;
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }

   if (bApplyChanges) {
      hRes = g_pActiveDesktop->ApplyChanges(AD_APPLY_ALL);
   }
   return bResultFind;
}

void CBkgrndSoundDlg::OnButtonStop() 
{
   CBkgrndSoundDlg::FindOrRemove(FALSE);
   ::EnableWindow(::GetDlgItem(m_hWnd, IDC_BUTTON_STOP), FALSE);
}

void CBkgrndSoundDlg::OnCheckRepeat() {
   BOOL bCheck = (m_ctrlCheckRepeat.GetCheck() == BST_CHECKED);
   if (m_strDuration.IsEmpty()) {
      //     
      //     ,   ...
      ::SetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_TIMEOUT), _T("0"));
      ::EnableWindow (::GetDlgItem(m_hWnd, IDC_EDIT_TIMEOUT), FALSE);
      m_ctrlComboPeriod.EnableWindow(FALSE);
   } else {
      ::EnableWindow (::GetDlgItem(m_hWnd, IDC_EDIT_TIMEOUT), bCheck);
      m_ctrlComboPeriod.EnableWindow(bCheck);
   }
}
